#ifdef __cplusplus
extern "C" {
#endif

typedef struct SPCCore_ID
{
  char songname[33];
  char gametitle[33];   
  char dumper[17];
  char comments[33];
  char author[33];   
  int playtime;   
  int fadetime;
  int emulator; /* 0=unknown, 1=zsnes, 2=snes9x, else=unknown */
} SPCCore_ID;

extern void SPCCore_Terminate(void);
extern void SPCCore_MuteSound(void);

extern void SPCCore_SetChannels(int n);
extern void SPCCore_SetBitness(int n);
extern void SPCCore_SetInterpolation(int n);
extern void SPCCore_SetEcho(int n);
extern void SPCCore_SetAlt(int n);
extern void SPCCore_SetRate(int n);
extern void SPCCore_SetPlaybackSpeed(int n);
extern void SPCCore_SetChannelStatus(int n, int s);
extern void SPCCore_SelectTrack(int n);

extern int SPCCore_GetAlt(void);
extern int SPCCore_GetEcho(void);
extern int SPCCore_GetRate(void);
extern int SPCCore_GetChannels(void);
extern int SPCCore_GetBitness(void);
extern int SPCCore_GetPlaybackSpeed(void);
extern int SPCCore_GetInterpolation(void);
extern int SPCCore_GetNumInterpolation(void);

extern int SPCCore_GetChannelStatus(int n);
extern int SPCCore_GetNumTracks();

/* return value: requested buffer size */
extern unsigned SPCCore_Init(void);

/* 0=ok, -1=fail */
extern int SPCCore_Load(const char*);

extern void SPCCore_Generate(void *buffer);

extern SPCCore_ID* SPCCore_GetID(const char*);

#ifdef __cplusplus
}
#endif
